#include "StdAfx.h"
#include "HelpWindow.h"

extern HINSTANCE g_hInstance;
static const wchar_t * g_pstrClassName = L"ImageResizerHelpWindow";
static const wchar_t * g_pstrImageMaker = L"Easy Image Resizer";
static const wchar_t * g_pstrAuthorString = L"Copyright: (C) 2006 James Bernard Schumacher III";
static const wchar_t * g_pstrVersionString = L"Version: 1.0.0.0";

bool HelpWindow::RegisterWindow() throw()
{
    WNDCLASSEXW wndClass;
    
    wndClass.cbSize = sizeof(WNDCLASSEXW);
    wndClass.style = CS_DBLCLKS;
    wndClass.hInstance = ::g_hInstance;
    wndClass.lpfnWndProc = reinterpret_cast<WNDPROC>(HelpWindow::WindowProcess);
    wndClass.hbrBackground = ::CreateSolidBrush(RGB(212,212,225));
    wndClass.hCursor = ::LoadCursor(NULL,IDC_ARROW);
    wndClass.hIcon = ::LoadIcon(NULL,IDI_APPLICATION);
    wndClass.hIconSm = wndClass.hIcon;
    wndClass.cbClsExtra = 0;
    wndClass.cbWndExtra = 0;
    wndClass.lpszMenuName = NULL;
    wndClass.lpszClassName = ::g_pstrClassName;
    
    return ::RegisterClassExW(&wndClass) != 0;
}

bool HelpWindow::UnregisterWindow() throw()
{
    return ::UnregisterClassW(::g_pstrClassName,::g_hInstance) != 0;
}

INT_PTR __stdcall HelpWindow::WindowProcess(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) throw()
{
    if (message == WM_PAINT)
    {
        PAINTSTRUCT ps;
        
        HDC hPaintDC = ::BeginPaint(hWnd,&ps);
        
        HFONT hTextFont = ::CreateFontW(12,5,0,0,600,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH | FF_DONTCARE,L"MS Sans Serif");
            
        HFONT hOldFont = (HFONT)::SelectObject(hPaintDC,hTextFont);
        
        const COLORREF clrOldText = ::SetTextColor(hPaintDC,RGB(0,0,0));
        const int nOldBkMode = ::SetBkMode(hPaintDC,TRANSPARENT);
        
        ::ExtTextOutW(hPaintDC,5,10,0,NULL,::g_pstrImageMaker,18,NULL);
        ::ExtTextOutW(hPaintDC,5,30,0,NULL,::g_pstrAuthorString,48,NULL);
        ::ExtTextOutW(hPaintDC,5,50,0,NULL,::g_pstrVersionString,16,NULL);
        
        ::SetBkMode(hPaintDC,nOldBkMode);
        ::SetTextColor(hPaintDC,clrOldText);
        ::SelectObject(hPaintDC,hOldFont);
        ::DeleteObject(hTextFont);
        
        ::EndPaint(hWnd,&ps);
    }
    else if (message == WM_CLOSE)
    {
        ::DestroyWindow(hWnd);
        return 0;
    }
    else if (message == WM_NCDESTROY)
    {
        ::PostQuitMessage(0);
        return 0;
    }
    return ::DefWindowProcW(hWnd,message,wParam,lParam);
}

bool HelpWindow::Show() throw()
{
    HWND hWnd = ::CreateWindowExW(WS_EX_CLIENTEDGE | WS_EX_APPWINDOW,::g_pstrClassName,L"About...",WS_CAPTION | WS_BORDER | WS_SYSMENU | WS_MINIMIZEBOX,
        CW_USEDEFAULT,0,310,105,NULL,NULL,NULL,NULL);
        
    ::ShowWindow(hWnd,SW_SHOWNORMAL);
        
    MSG msg;
    long nCheck = 0;
    
    do
    {
        nCheck = ::GetMessage(&msg,0,0,0);
        
        if (nCheck == 0 || nCheck == -1)
        {
            break;
        }
        
        ::TranslateMessage(&msg);
        ::DispatchMessage(&msg);
        
    } while (true);
    
    return true;
}
