#ifndef __PUZZLE_WINDOW_H__
#define __PUZZLE_WINDOW_H__

#ifndef __cplusplus
#error ImageWindow requires C++ compilation
#endif // !defined __cplusplus

#include <pshpack8.h>

class ImageWindow
{
public:
    friend class MainWindow;
    // Construction/Destruction
    ImageWindow() throw();
    virtual ~ImageWindow() throw();
    // Member Functions
    void LoadBitmap(const wchar_t * pstrFileName) throw();
    void SaveBitmap(const wchar_t * pstrFileName) throw();
    bool Create(const wchar_t * pstrTitle,unsigned long dwStyle,unsigned long dwExtendedStyle,
        long x,long y,long nWidth,long nHeight,HWND hParent) throw();
    bool Show(int nShow) throw();
    bool Invalidate(bool bErase) throw();
    void Close() throw();
    // Static Member Functions
    static bool RegisterWindow() throw();
    static bool UnregisterWindow() throw();
private:
    // Member Variables
    HWND Handle;
    HWND StatusWindow;
    HBITMAP m_hBitmap;
    long Width;
    long Height;
    // Window Process
    INT_PTR WindowProcess(UINT message,WPARAM wParam,LPARAM lParam) throw();
    static INT_PTR __stdcall HandleWindowProcess(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) throw();
    // Message Handlers
    void OnPaint(HDC hDC) throw();
    void OnSize(WPARAM wParam,LPARAM lParam) throw();
};

#include <poppack.h>

#endif // !defined __PUZZLE_WINDOW_H__
