#ifndef __MAINWINDOW_H__
#define __MAINWINDOW_H__

#ifndef __cplusplus
#error MainWindow requires C++ compilation
#endif // !defined __cplusplus

#include "ImageWindow.h"

#include <pshpack8.h>

class MainWindow
{
public:
    // Construction/Destruction
    MainWindow() throw();
    ~MainWindow() throw();
    // Member Functions
    bool Create(const wchar_t * pstrTitle,unsigned long dwStyle,unsigned long dwExtendedStyle,
        long x,long y,long nWidth,long nHeight) throw();
    bool Show(int nShow) throw();
    bool Invalidate(bool bErase) throw();
    // Static Member Functions
    static bool RegisterWindow() throw();
    static bool UnregisterWindow() throw();
private:
    // Member Variables
    HWND Handle;
    HMENU MenuHandle;
    HWND StatusWindow;
    long Width;
    long Height;
    ImageWindow * ImageObject;
    // Window Process
    INT_PTR WindowProcess(UINT message,WPARAM wParam,LPARAM lParam) throw();
    static INT_PTR __stdcall HandleWindowProcess(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) throw();
    // Message Handlers
    INT_PTR OnCreate(LPCREATESTRUCTW lpCreate) throw();
    INT_PTR OnCommand(WPARAM wParam,LPARAM lParam) throw();
    void OnSize(WPARAM wParam,LPARAM lParam) throw();
    void OnClose() throw();
    // Command Handlers
    void OnFileOpen() throw();
    void OnFileSave() throw();
    void OnFileExit() throw();
};

#include <poppack.h>

#endif // !defined __MAINWINDOW_H__
